"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamicTextfield = void 0;
const react_1 = require("react");
const react_2 = require("@fluentui/react");
const react_3 = __importDefault(require("react"));
const OnKeyDown = (e, type, allowNegativeNumbers) => {
    // disable 'e' in number fields
    if (type === "number" && e.keyCode === 69)
        e.preventDefault();
    // disable '-' and '+' in number fields
    if (type === "number" && (e.keyCode === 187 || (!allowNegativeNumbers && e.keyCode === 189)))
        e.preventDefault();
};
const DynamicTextfield = (props) => {
    var _a, _b, _c;
    const [value, setValue] = (0, react_1.useState)(props.value);
    (0, react_1.useEffect)(() => setValue(props.value), [props.value]);
    const onChange = (ev, value) => {
        var _a;
        setValue(value);
        props.onChange((((_a = props.config) === null || _a === void 0 ? void 0 : _a.type) === "number" ? Number(value) : value));
    };
    return react_3.default.createElement(react_2.TextField
    // key={ props.key }
    , { 
        // key={ props.key }
        defaultValue: (value !== null && value !== void 0 ? value : ""), onKeyDown: (event) => { var _a, _b; return OnKeyDown(event, (_a = props.config) === null || _a === void 0 ? void 0 : _a.type, (_b = props.config) === null || _b === void 0 ? void 0 : _b.allowNegativeNumbers); }, onChange: onChange, disabled: props.disabled, type: ((_a = props.config) === null || _a === void 0 ? void 0 : _a.type) || "text", multiline: (_b = props.config) === null || _b === void 0 ? void 0 : _b.multiline, resizable: (_c = props.config) === null || _c === void 0 ? void 0 : _c.resizable, onBlur: () => props.onBlur(props.value), errorMessage: props.errorMessage, canRevealPassword: true });
};
exports.DynamicTextfield = DynamicTextfield;
// TODO: why do this fuck up? form item seems to reset sporadically, when memo is used (ewi)
// because of callback functions cahnged on re-render (ewi)
// try to use usecallback?
// const preventUpdate = (prev: any, next: any) => {
//     return prev.value === next.value
//       && prev.errorMessage === next.errorMessage;
// }
// export const DynamicTextfield = memo(DynamicTextfieldComp, preventUpdate) as typeof DynamicTextfieldComp;
//# sourceMappingURL=DynamicTextfield.js.map